///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	Contains custom lists.
 *	\file		IceCustomList.h
 *	\author		Pierre Terdiman
 *	\date		April, 4, 2000
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef __ICECUSTOMLIST_H__
#define __ICECUSTOMLIST_H__

	class ICECORE_API CustomList : public Cell
	{
		public:
										CustomList();
										~CustomList();

						bool			Init(FieldDescriptor* desc, udword nbvalues, bool symbolic=false);

						bool			IsCompatible(FieldDescriptor* fld)	{ return (fld && fld->Type==mBaseType && fld->UserParam==mType);	}

		__forceinline	udword			GetNbValues()						{ return mNbValues;					}
		__forceinline	void*			GetValues()							{ return mValues;					}
		__forceinline	String*			GetSymbolicValues()					{ return mSymbolic;					}

						bool			BuildSymbolicValue(udword index, String& value);

		__forceinline	eFieldType		GetBaseType()						{ return mBaseType;					}
		__forceinline	udword			GetCustomType()						{ return mType;						}

						bool			Replace(Cell* cell, FieldDescriptor* field, udword index);
		protected:
		// List values
						udword			mNbValues;		//!< Number of values in the list
						udword			mValueSize;		//!< Size in bytes of a single value
						void*			mValues;		//!< List of values
						String*			mSymbolic;		//!< Possible extra list of symbolic values
		// List descriptor
						eFieldType		mBaseType;		//!< Base type for values
						udword			mType;			//!< User subtype for values
		public:
		// List identifier
						udword			mUserID;		//!< Extra possible ID, left to the user - not used at all by the CustomList
	};


//	ICECORE_API CustomList* CreateDefaultCustomList(eFieldType type);

#endif // __ICECUSTOMLIST_H__
