///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	Contains exported dynamic identifiers.
 *	\file		IceDynID.h
 *	\author		Pierre Terdiman
 *	\date		April, 4, 2000
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef __ICEDYNID_H__
#define __ICEDYNID_H__

//	Wordlist:
//	gEC_	global error code identifier
//	gID_	global object identifier
//	gKM_	global kernel message identifier

extern ICECORE_API DynID gEC_OutOfMemory;
extern ICECORE_API DynID gEC_FileNotFound;
extern ICECORE_API DynID gEC_InvalidCallback;
extern ICECORE_API DynID gEC_ReplicationFailed;
extern ICECORE_API DynID gEC_TooManyMsgs;
extern ICECORE_API DynID gEC_CorruptedKernel;
extern ICECORE_API DynID gEC_LostCells;
extern ICECORE_API DynID gEC_IncompatibleFields;

extern ICECORE_API DynID gID_DataBlock;
extern ICECORE_API DynID gID_CustomList;

extern ICECORE_API DynID gKM_SelfDestruct;
extern ICECORE_API DynID gKM_CorruptedDeletion;
extern ICECORE_API DynID gKM_InvalidReference;
extern ICECORE_API DynID gKM_CellModification;
extern ICECORE_API DynID gKM_FieldModification;

#endif // __ICEDYNID_H__
