///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 *	Contains message-related code.
 *	\file		IceMessage.h
 *	\author		Pierre Terdiman
 *	\date		April, 4, 2000
 */
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Include Guard
#ifndef __ICEMESSAGE_H__
#define __ICEMESSAGE_H__

	//! Message types
	enum MsgType
	{
		MSG_ERROR			= 1,					//!< Error message
		MSG_SYSTEM			= 2,					//!< Kernel message
		MSG_USER			= 3,					//!< User-defined message
		MSG_FORCE_DWORD		= 0x7fffffff
	};

	//! Message structure
	class ICECORE_API IceMsg
	{
		public:
									IceMsg();
									~IceMsg();

		__forceinline	bool		SetCustomText(const char* txt)	{	return mText.Set(txt);	}

						MsgType		mType;			//!< Message type
						DynID		mID;			//!< Message identifier
						udword		mParam;			//!< Misc parameter
						String		mText;			//!< Custom text
	};

	// Global messages
	ICECORE_API	bool		SetMsg(IceMsg& msg);
	ICECORE_API	bool		GetMsg(IceMsg& msg);
	ICECORE_API	void		FlushMsgs();
	ICECORE_API	String*		TranslateMsg(IceMsg& msg);

#endif // __ICEMESSAGE_H__
